package dragon.rail.sopwith;

import dragon.rail.sopwith.util.Float2;


public class Bullet {
	
	public final static int	BULLET = 0;
	public final static int	BOMB = 1;
//	public final static int BAZOOKA = 2;
//	public final static int	FLAME = 3;
	
	public final static byte OWNER_PLAYER = 0;
	public final static byte OWNER_PLANE = 1;
	public final static byte OWNER_TANK = 2;

	/*public int xSpeed;
	public int ySpeed;
	public int yInc;*/
	
	private Float2 position;
	private int speed = 3;
	private int angle = 0;

	public int x;
	public int y;
	public int colY;	// Yoffset for collision detection
	public int colX;	// Xoffset for collision detection
	public int w;
	public int h;
	
//	public int					direction;

	public boolean visible;
	public boolean harmless;

	public int 					bType;
	public int 					bOwner;
	public int 					bulletTime;
	//public int maxBulletTime;													// same
//	public byte 				mirrorFrame;

	public int 					energy;
	public int					alpha;

	public boolean 				died;
	public boolean 				offscreen;
	public int 					animDelay;
//	public int 					SpriteSet;

	
	boolean						deleted;
	
	public Bullet() { deleted=true; };
	
	
	public void init(int aOwner,int aType, int aX, int aY, int aXspeed, int aYspeed,int aEnergy,int aSpriteSet) {
		deleted=false;
		
//        SpriteSet=aSpriteSet;
		died=false;
		offscreen=false;
		bType=aType;
		bOwner=aOwner;

		x=aX;
		y=aY;
//		xSpeed=0;
//		ySpeed=0;

		// not left or right by default
//		direction=0;
		
		
		visible=true;
		harmless=false;
		alpha=255;
		
		switch (bType) {
			case BULLET:
				w=8;
				h=5;
				if (aXspeed>0) {
					// to right
//					direction=1;
					colY=0;
//					xSpeed=aXspeed*10;
				} else {
					// to left
//					direction=-1;
					colY=5;
//					xSpeed=aXspeed*10;
				}
				
				if (bOwner==OWNER_PLAYER) colX=0;
				else colX=8;
				
				bulletTime=24;
			break;
			
			case BOMB:
				w=7;
				h=10;
				colX=23;
				colY=0;

				// basically until we hit the floor and go boom!
				bulletTime=9999;
			break;
			
			
			/*case BAZOOKA:
				w=10;
				h=7;
				colX=30;
				if (aXspeed>0) {
					colY=0;
					direction=1;
					xSpeed=aXspeed*10;
				} else {
					colY=7;
					direction=-1;
					xSpeed=aXspeed*10;
				}
				
				bulletTime=200;
			break;*/
			
			
			/*case FLAME:
				w=16;
				h=16;
				colX=0;
				colY=18;
				xSpeed=aXspeed*6;
				ySpeed=0;
				animDelay=3;
				bulletTime=200;
			break;*/
		}

	}

	public final void update(int floorY) {
		
		if (bulletTime>0) bulletTime--;
		else died=true;
		
		switch (bType) {
			/*case BOMB:
//				if (ySpeed<8) ySpeed++;
				if (y+h>floorY) {
//					died=true;
//					myCanvas.fxAdd(x-8, y, FX.EXPLODE, 0);
				}
			break;*/
			
			
			/*case FLAME:
				if (animDelay>0) animDelay--;
				else {
					animDelay=3;
					colX+=16;
					if (colX>48) died=true;
					if (ySpeed>-1) ySpeed--;
					if (xSpeed>0) xSpeed--;
					else if (xSpeed<0) xSpeed++;
				}
			break;*/
		}
		
//		x+=xSpeed;
//		y+=ySpeed;
		
	}
	

	public final boolean collidesWith(int tx, int ty, int tw, int th, int aOwner) {
		boolean collide=false;

//		if ((bOwner!=aOwner) && (bOwner!=OWNER_ANYONE)) return false;

		int cw=x+w;
		int ch=y+h;

		if ((tx<=cw) && (tx+tw>=x) && (ty<=ch) && (ty+th>=y)) collide=true;

		return collide;
	}
}
