package dragon.rail.sopwith;

import android.graphics.Bitmap;
import android.graphics.Canvas;
import android.graphics.Rect;
import dragon.rail.sopwith.util.Angle;
import dragon.rail.sopwith.util.Float2;

public class Player {
	private static final int BMP_ROWS = 13;
	private static final int BMP_COLUMNS = 2;
	private Float2 position;
	private int speed = 3;
	private SopwithReduxView gameView;
	private Bitmap bmp;
	private int currentFrame = 0;
	private int width;
	private int height;
	private float angle = 0;
//	private enum 

	public Player(SopwithReduxView gameView, Bitmap bmp) {

		this.gameView = gameView;
		this.bmp = bmp;
//		this.width = bmp.getWidth() / BMP_COLUMNS;
//		this.height = bmp.getHeight() / BMP_ROWS;
		this.width = 32;
		this.height = 32;
		
		position = new Float2(100, 100);
	}
	
	public void playerUp() {
		
		if (angle == 0) {
			angle = 330;
		} else {
			angle = angle - 30;
		}
		
		System.out.println("angle: " + angle);
	}
	
	public void playerDown() {
		
		if (angle == 330) {
			angle = 0;
		} else {
			angle = angle + 30;
		}
		
		
		System.out.println("angle: " + angle);
	}

	private void update() {

		float radians = Angle.degToRad(angle);
		Float2 velocity = new Float2((Math.cos(radians) * speed), (Math.sin(radians) * speed));
		
		position.add(velocity);
		
		switch ((int)angle) {
		case 0:
			currentFrame = 4;
			break;
		case 30:
			currentFrame = 5;
			break;
		case 60:
			currentFrame = 6;
			break;
		case 90:
			currentFrame = 7;
			break;
		case 120:
			currentFrame = 8;
			break;
		case 150:
			currentFrame = 9;
			break;
		case 180:
			currentFrame = 10;
			break;
		case 210:
			currentFrame = 11;
			break;
		case 240:
			currentFrame = 12;
			break;
		case 270:
			currentFrame = 1;
			break;
		case 300:
			currentFrame = 2;
			break;
		case 330:
			currentFrame = 3;
			break;
		default:
			currentFrame = 0;
			break;
		}
		
	}

	public void onDraw(Canvas canvas) {

		update();
		
		int srcX = 0 * width;
		int srcY = currentFrame * height;
		Rect src = new Rect(srcX, srcY, srcX + width, srcY + height);
		int x = (int) position.x;
		int y = (int) position.y;
		Rect dst = new Rect(x, y, x + width, y + height);
		canvas.drawBitmap(bmp, src, dst, null);
	}
}
